# Задача 2. Свой zip 2
# Написав аналог функции zip на собеседовании, вы вспомнили, что этот код можно сделать даже лучше, и резко вырвали
# листок с кодом из рук работодателя, оставив его в недоумении. Напишите функцию, которая будет являться аналогом
# функции zip и сделайте так, чтобы программа работала с любыми итерируемыми типами данных. Циклами за исключением
# генераторов, условными операторами и функциями определения типа (isinstance или type) пользоваться нельзя.
# Функция должна возвращать список из пар кортежей.
# Примеры:
# a = [{‘x’: 4}, ‘b’, ‘z’, ‘d’]
# b = (10, {20,}, [30], ‘z’)
# print(my_zip(a, b)) -> [({‘x’: 4}, 10), (‘b’, {20}), (‘z’, [30]), (‘d’, ‘z’)]
# a = [1, 2, 3, 4, 5]
# b = {1: ‘s’, 2: ‘q’, 3: 4}
# x = (1, 2, 3, 4, 5)
# print(my_zip(a, b, x)) -> [(1, 1, 1), (2, 2, 2), (3, 3, 3)]


def my_zip(*args: iter, count=0, zip_list=list()):
    args = tuple(map(list, args))
    try:
        zip_list.append(tuple(i[count] for i in args))
        my_zip(*args, count=count + 1, zip_list=zip_list)
    except IndexError:
        return zip_list
    return zip_list


a = [{'x': 4}, 'b', 'z', 'd']
b = (10, {20, }, [30], 'z', 15)
b1 = {1: 's', 20: 'q', 3: 4}
x = (1, 2, 8, 15)

print(my_zip(b1, b, x, a))


